=== debian/changelog ===
aubio (0.4.9-5) unstable; urgency=medium

  * Salvage package on behalf of the debian-multimedia team (Closes: #1114989)
    + Fix Vcs-* stanzas to point to the multimedia-team repository

  * Add patch to fix FTBFS with ffmpeg-8.
    Thanks to Bernd Kuhls (Closes: #1115008)
  * Update Py3.12 patch to use raw-strings in regular expressions
  * Refresh patches with 'gbp pq' and group them by topic
  * Drop obsolete Rules-Requires-Root stanza.
  * Apply 'wrap-and-sort -ast'
  * Bump dh-compat to 13
  * Suppress false-positives in blhc check
  * Update copyright information
    + Add myself to copyright holders
    + Add 'licensecheck' target
    + Generate d/copyright_hints
  * Update d/watch to version 5
  * Update git repository layout to follow DEP-14
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 07 Oct 2025 10:08:21 +0200

aubio (0.4.9-4.7) unstable; urgency=medium

  * Non-maintainer upload.
  * Relax assert_equal to assert_almost_equal in unittests (Closes: #1095283)
  * Refresh patches
  * B-D on dh-sequence-numpy3
  * Use execute_after_dh_... rather than override_dh_... where appropriate

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 09 Feb 2025 23:11:11 +0100

aubio (0.4.9-4.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Add Numpy 2.x patch (Closes: #1094369)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 05 Feb 2025 20:17:52 +0100

aubio (0.4.9-4.5) unstable; urgency=medium

  * Non-maintainer upload.

  * Backport fix for FTBFS with FFMpeg-7 from upstream via Ubuntu
    (Closes: #1072399)
  * Backport fix for FTBFS with Python3.12 from Ubuntu.
    Thanks to Zixing Liu <zixing.liu@canonical.com> (Closes: #1074827)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 05 Oct 2024 01:40:39 +0200

aubio (0.4.9-4.4) unstable; urgency=medium

  * Non-maintainer upload.

  [ Vladimir Petko ]
  * d/p/waflib-py312.patch: cherry-pick waf patch to resolve python 3.12
    build failure due to imp module removal. Closes: #1061736.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Feb 2024 00:46:01 +0100

aubio (0.4.9-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * waf compatibility with Python3.11 (Closes: #1028178)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 15 Jan 2023 21:40:50 +0100

aubio (0.4.9-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch to build against ffmpeg-5.0 (Closes: #1004787)
  * Add salsa-ci configuration
  * Call dh_numpy3 to add dependency on numpy abi

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 30 Jun 2022 22:35:01 +0200

aubio (0.4.9-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Change build-depends from libavresample-dev to libswresample-dev
    the build logs and binary dependencies indicate the package was
    already using libswresample ( Closes: 971319 ).

 -- Peter Michael Green <plugwash@debian.org>  Thu, 09 Sep 2021 18:11:53 +0000

aubio (0.4.9-4) unstable; urgency=medium

  * debian/tests/control: remove py2 tests

 -- Paul Brossier <piem@debian.org>  Wed, 08 Jan 2020 13:39:53 +0100

aubio (0.4.9-3) unstable; urgency=medium

  * debian/control: remove python-aubio package (closes: #936161)
  * debian/rules: use only python3, cleaner py3 clean
  * debian/patches/wscript_py3.patch: add patch to build with current python
  * debian/upstream/metadata: add basic upstream description and reference
  * debian/control: bump to debhelper-compat 12, remove debian/compat,
    bump S-V to 4.4.1, add Rules-Requires-Root: no
  * debian/aubio-tools.manpages: install from debian/tmp
  * debian/libaubio-doc.*: move html doc to /u/s/d/libaubio-dev/api
  * debian/libaubio-doc.doc-base: update author email
  * debian/libaubio-doc.links: fix jquery link

 -- Paul Brossier <piem@debian.org>  Sat, 04 Jan 2020 18:34:15 +0100

aubio (0.4.9-2) unstable; urgency=medium

  * Add upstream patches to fix FTBFS on powerpc and i386

 -- Paul Brossier <piem@debian.org>  Fri, 21 Jun 2019 14:46:30 +0200

aubio (0.4.9-1) unstable; urgency=medium

  * New upstream version 0.4.9 (closes: #480018, #930186)
  * Fixes security issues (CVE-2018-19800, CVE-2018-19801, CVE-2018-19802)
  * debian/tests/control: also install built binaries
  * debian/patches: remove patches integrated upstream
  * debian/control: bump to S-V 4.3.0
  * debian/control, debian/tests: switch b-d from nose2 to pytest
  * debian/rules: switch to pytest, update clean target
  * debian/patches/fixtypos.patch: fix typos
  * debian/patches/series: remove patches integrated upstream
  * debian/libaubio-doc.dob-base: move documentation to api folder
  * debian/libaubio5.symbols: add new symbols since 0.4.8, remove unused
    symbols previously exported, add Build-Depends-Package field
  * debian/upstream/signing-key.asc: minimize key export

 -- Paul Brossier <piem@debian.org>  Thu, 20 Jun 2019 12:01:41 +0200
