=== debian/control ===
Source: aubio
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Paul Brossier <piem@debian.org>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-numpy3,
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libfftw3-dev,
 libjack-dev | libjack-jackd2-dev,
 libpython3-dev,
 libsamplerate-dev,
 libsndfile1-dev,
 libswresample-dev,
 libtool,
 python3-all-dev,
 python3-numpy,
 python3-pytest,
 python3-setuptools,
 sox,
 txt2man,
Build-Depends-Indep:
 doxygen,
 libjs-jquery,
 libjs-mathjax,
Standards-Version: 4.7.2
Homepage: https://aubio.org
Vcs-Git: https://salsa.debian.org/multimedia-team/aubio.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/aubio

Package: libaubio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libaubio5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for audio and music analysis, synthesis, and effects
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package contains the development files for libaubio.

Package: libaubio5
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libaubio4,
Description: library for audio segmentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the shared library libaubio.

Package: aubio-tools
Architecture: any
Depends:
 python3-aubio (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: library for audio segmentation -- utilities
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides command line tools to run the different algorithms.

Package: libaubio-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-mathjax,
 ${misc:Depends},
Description: library for audio segmentation -- documentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the documentation for the C interface.

Package: python3-aubio
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 python3-matplotlib,
Description: Python 3 interface for aubio, a library for audio segmentation
 aubio gathers a set of functions for audio signal segmentation and labelling.
 The library contains a phase vocoder, onset and pitch detection functions, a
 beat tracking algorithm and other sound processing utilities.
 .
 This package provides the aubio module for Python 3.
