=== debian/tests/control ===
Tests:
 py3xtests,
Depends:
 python3-pytest,
 sox,
 @,
Restrictions:
 allow-stderr,
