=== debian/watch ===
Version: 5

Source: https://aubio.org/pub/
Matching-Pattern: aubio-([0-9.]*)\.tar\.bz2
Pgpsigurlmangle: s/$/.asc/
